/*****************************************************************************/
/* Implementation of the ASSERT macro                                        */
/*                                                                           */
/* Copyright (c) 2005 Harry Butterworth IBM Corporation                      */
/*                                                                           */
/* This program is free software; you can redistribute it and/or modify it   */
/* under the terms of the GNU General Public License as published by the     */
/* Free Software Foundation; either version 2 of the License, or (at your    */
/* option) any later version.                                                */
/*                                                                           */
/* This program is distributed in the hope that it will be useful, but       */
/* WITHOUT ANY WARRANTY; without even the implied warranty of                */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General */
/* Public License for more details.                                          */
/*                                                                           */
/* You should have received a copy of the GNU General Public License along   */
/* with this program; if not, write to the Free Software Foundation, Inc.,   */
/* 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA                   */
/*                                                                           */
/*****************************************************************************/

#ifndef BLKBACK2_ASSERT_H
#define BLKBACK2_ASSERT_H

#include <linux/kernel.h>

static inline void
assert_failed(const char *function, int line, const char *statement)
{
	printk(KERN_ERR "blkback2 assert failed: %s line %d, statement %s\n",
						function, line, statement);
	BUG();
}

#define ASSERT( S ) ((S)?(void)0:assert_failed(__FUNCTION__, __LINE__, #S))

#endif
