/*****************************************************************************/
/* Copyright (c) 2005 Harry Butterworth IBM Corporation                      */
/*                                                                           */
/* This program is free software; you can redistribute it and/or modify it   */
/* under the terms of the GNU General Public License as published by the     */
/* Free Software Foundation; either version 2 of the License, or (at your    */
/* option) any later version.                                                */
/*                                                                           */
/* This program is distributed in the hope that it will be useful, but       */
/* WITHOUT ANY WARRANTY; without even the implied warranty of                */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General */
/* Public License for more details.                                          */
/*                                                                           */
/* You should have received a copy of the GNU General Public License along   */
/* with this program; if not, write to the Free Software Foundation, Inc.,   */
/* 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA                   */
/*                                                                           */
/*****************************************************************************/

#ifndef BLKBACK2_RESOURCE_H
#define BLKBACK2_RESOURCE_H

#include <asm-xen/xenidc.h>

int blkback2_resource_class_init(void);

void blkback2_resource_class_exit(void);

struct blkback2_device;

typedef enum {
	blkback2_resource_state_i,
	blkback2_resource_state_i_st,
	blkback2_resource_state_i_st_ft,
	blkback2_resource_state_i_st_ms
} blkback2_resource_state;

struct blkback2_resource {
	struct blkback2_device                    *device;
	struct list_head                           link;
	spinlock_t                                 lock;
	blkback2_resource_state                    state;
	struct xenidc_reserve_and_map_rbr_request  reserve_and_map_rbr_request;
	struct xenidc_map_rbr_request_element      request_element;
	struct xenidc_work                         submit_bio_1_work;
	struct xenidc_endpoint_transaction        *transaction;
	xenidc_error                               transaction_error;
	int                                        rbr_mapped;
	atomic_t                                   completions_out;
};

int
blkback2_resource_init(struct blkback2_resource *resource,
struct blkback2_device *device);

void
blkback2_resource_exit(struct blkback2_resource *resource);

void
blkback2_resource_start_transaction(struct blkback2_resource *resource,
struct xenidc_endpoint_transaction *transaction);

void blkback2_resource_flush_transaction(struct blkback2_resource *resource);

#endif
