/*****************************************************************************/
/* Simple trace macros                                                       */
/*                                                                           */
/* Copyright (c) 2005 Harry Butterworth IBM Corporation                      */
/*                                                                           */
/* This program is free software; you can redistribute it and/or modify it   */
/* under the terms of the GNU General Public License as published by the     */
/* Free Software Foundation; either version 2 of the License, or (at your    */
/* option) any later version.                                                */
/*                                                                           */
/* This program is distributed in the hope that it will be useful, but       */
/* WITHOUT ANY WARRANTY; without even the implied warranty of                */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General */
/* Public License for more details.                                          */
/*                                                                           */
/* You should have received a copy of the GNU General Public License along   */
/* with this program; if not, write to the Free Software Foundation, Inc.,   */
/* 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA                   */
/*                                                                           */
/*****************************************************************************/

#ifndef BLKBACK2_TRACE_H
#define BLKBACK2_TRACE_H

#include <linux/config.h>
#include <linux/kernel.h>

#ifdef CONFIG_XEN_BLKDEV2_BACKEND_TRACE

#define trace_info(format, ...) \
printk(KERN_INFO "blkback2 %s: " format "\n", __FUNCTION__, ## __VA_ARGS__)
#define trace() trace_info("")

#else

#define trace_info(format, ...)
#define trace()

#endif

#endif
